<!DOCTYPE html>

<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Tugas Vue Router</title>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://unpkg.com/vue/dist/vue.js"></script>
  <script src="https://unpkg.com/vue-router/dist/vue-router.js"></script>
</head>

<body>



    <div id="app">
        <div>
            <button><router-link to="/halaman1">Halaman 1</router-link></button> 
            <button><router-link to="/halaman2">Halaman 2</router-link></button>
            <button><router-link to="/halaman3">Halaman 3</router-link></button>
        </div>

        <br>

        <div>
            <router-view></router-view>
        </div>

    </div>

    <template id="page1">
        <h2>Ini Halaman 1</h2>
    </template>

    <template id="page2">
        <h2>Ini Halaman 2</h2>
    </template>

    <template id="page3">
        <h2>Ini Halaman 3</h2>
    </template>

 
    <script>

        var Component1 = Vue.component('Component1', {
            template : '#page1'
        })

        var Component2 = Vue.component('Component2', {
            template : '#page2'
        })

        var Component3 = Vue.component('Component3', {
            template : '#page3'
        })


        var  isAuthenticated = () => {
            return true
        }

        var  isAuthenticatedAdmin = () => {
            return true
        }

        const routes = [
            { path: '/halaman1', component: Component1, meta: {requiresAuth: true} },
            { path: '/halaman2', component: Component2, meta: {requiresAuth: true} },
            { path: '/halaman3', component: Component3, meta: {requiresAuth: true} },
            
        ]

        const router = new VueRouter({
        routes 
        })

        router.beforeEach((to, from, next) => {
            if (to.matched.some((record) => record.meta.requiresAuth)) {

                let user = {
                    login : true,
                    role : 'admin'
                }

                if (user.login && user.role == 'admin') {
                    next()
                    alert('Berhasil Masuk 1')
                    console.log(isAuthenticated)
                
                } else if(user.login && user.role == null) {
                    next()
                        alert('Berhasil Masuk 2')
                        console.log(isAuthenticated)
                } else {
                    next(false)
                    alert('Hanya untuk yang sudah login')
                }
            }
        })

        let vm = new Vue({
            el: '#app',
            router,
            data: {
                components : {
                    Component1,
                    Component2,
                    Component3,
                },
            },

            computed: {

            },

            methods: {

            }
        })

    </script>

</body>
</html>